<?php
// +----------------------------------------------------------------------
// | [ UtilService  ]
// +----------------------------------------------------------------------
// | Copyright (c) 2018-2020 rights reserved.
// +----------------------------------------------------------------------
// | Author: TABLE ME
// +----------------------------------------------------------------------
// | Date: 2020-08-25 17:30
// +----------------------------------------------------------------------
namespace library\services;

use library\exceptions\UtilException;
use library\services\upload\Upload as Upload;
use think\facade\Config;
use dh2y\qrcode\QRcode;

class  UtilService {

    /**
     * 参数判断模型
     * @param $params   [
     *      [ 'parm1'   =>  'post|get',
     *        'parm2'   =>  '',//默认值
     *        'parm3'   =>  'empty',//函数
     *        'parm4'   =>  '错误信息',
     *      ]
     * ]
     * @param null $request
     * @param bool $suffix
     */
    public static function getMore($params, $request = null, $suffix = false)
    {
        $fiAr = ['empty','is_null','isset'];
        if ($request === null) {
            $request = request();
        }
        $i = 0;
        foreach ($params as $param) {
            if (!is_array($param)) {
                $p[$suffix == true ? $i++ : $param] = $request->param($param);
            } else {
                if (!isset($param[1])) $param[1] = null;
                if (!isset($param[2])) $param[2] = '';
                if (!isset($param[3])) $param[3] = '';
                if (is_array($param[0])) {
                    $name = $param[0][0];
                    $keyName = $param[0][0];
                    foreach ($param[0] as $k=>$v) {
                        $name = $k;
                        $keyName = $v;
                    }
                } else {
                    $name = $param[0];
                    $keyName = $param[0];
                }
                $value = $request->param($name, $param[1]);
                $p[$suffix == true ? $i++ : $keyName ] = $value;
                if(in_array($param[2],$fiAr)) {
                    if($param[2] == 'empty') {
                        if(empty($value)) {
                            throw new UtilException($param[3]);
                        }
                    }
                    if($param[2] == 'is_null') {
                        if(is_null($value)) {
                            throw new UtilException($param[3]);
                        }
                    }
                    if($param[2] == 'isset') {
                        if(!isset($value)) {
                            throw new UtilException($param[3]);
                        }
                    }
                } else {
                    if (!empty($param[2]) && is_string($param[2]) && !function_exists($param[2])) {
                        throw new UtilException('方法' . $param[2] . '不存在');
                    }

                    if (!empty($param[2]) && !$param[2]($request->param($name, $param[1]))) {
                        throw new UtilException($param[3]);
                    }
                }
            }
        }
        return $p;
    }

    /**
     * 参数解析 | 返回
     * @param $params
     * @param $data
     */
    public static function getParam($params,$data) {
        $result = [];
        foreach ($data as $k => $vv) {
            $d = [];
            foreach ($params as $v) {
                if (is_array($v)) {
                    $alias   = empty($v[0]) ? $v[1] : $v[0];
                    $key     = $v[1];
                    $callStr = empty($v[2]) ? '' : $v[2];
                    $val     = $vv[$key];
                    if($callStr instanceof \Closure) {
                        $d[$alias] = $callStr($val);
                    }
                    else if(!empty($callStr)){
                        $e       = null;
                        $callStr = str_replace('$1', '$val', $callStr);
                        eval('$e =' . $callStr . ';');
                        $d[$alias] = $e;
                    }
                    else {
                        $d[$alias] = $val;
                    }
                } else {
                    $d[$v] = $vv[$v];
                }
            }
            $result[] = $d;
        }

        return $result;
    }

    /**
     * 获取POST请求的数据
     * @param $params
     * @param null $request
     * @param bool $suffix
     * @return array
     * @throws \Exception
     */
    public static function postMore($params, $request = null, $suffix = false)
    {
        if ($request === null) $request = app('request');
        $p = [];
        $i = 0;
        foreach ($params as $param) {
            if (!is_array($param)) {
                $p[$suffix == true ? $i++ : $param] = $request->param($param);
            } else {
                if (!isset($param[1])) $param[1] = null;
                if (!isset($param[2])) $param[2] = '';
                if (!isset($param[3])) $param[3] = '';
                if (!isset($param[4])) $param[4] = '';
                if (!isset($param[5])) $param[5] = '';
                if (is_array($param[0])) {
                    $name = is_array($param[1]) ? $param[0][0] . '/a' : $param[0][0] . '/' . $param[0][1];
                    $keyName = $param[0][0];
                } else {
                    $name = is_array($param[1]) ? $param[0] . '/a' : $param[0];
                    $keyName = $param[0];
                }
                $p[$suffix == true ? $i++ : (isset($param[3]) && $param[3] ? $param[3] : $keyName)] = $request->param($name, $param[1], $param[2]);
                if (!empty_check($param[4])) {
                    if (!is_array($param[4])) {
                        if (is_string($param[4]) && !function_exists($param[4])) {
                            throw new UtilException('验证的方法' . $param[4] . '未定义');
                        }
                        if ($param[4]($request->param($name, $param[1], $param[2]))) {
                            throw new UtilException($param[5]);
                        }
                    } else {
                        foreach ($param[4] as $k => $v) {
                            if (is_string($v) && !function_exists($v)) {
                                throw new UtilException('验证的方法' . $v . '未定义');
                            }
                            if ($v($request->param($name, $param[1], $param[2]))) {
                                throw new UtilException(is_array($param[5]) ? $param[5][$k] : $param[5]);
                            }
                        }
                    }
                }
            }
        }
        return $p;
    }

    /**
     * TODO 生成分享二维码图片
     * @param array $config
     * @param $path
     * @return array|bool|string
     * @throws \Exception
     */
    public static function setSharePoster($config = array(), $path)
    {
        $imageDefault = array(
            'left' => 0,
            'top' => 0,
            'right' => 0,
            'bottom' => 0,
            'width' => 100,
            'height' => 100,
            'opacity' => 100
        );
        $textDefault = array(
            'text' => '',
            'left' => 0,
            'top' => 0,
            'fontSize' => 32,       //字号
            'fontColor' => '255,255,255', //字体颜色
            'angle' => 0,
        );
        $background = $config['background'];//海报最底层得背景
        if (substr($background, 0, 1) === '/') {
            $background = substr($background, 1);
        }
        $backgroundInfo = getimagesize($background);
        $background = imagecreatefromstring(file_get_contents($background));
        $backgroundWidth = $backgroundInfo[0];  //背景宽度
        $backgroundHeight = $backgroundInfo[1];  //背景高度
        $imageRes = imageCreatetruecolor($backgroundWidth, $backgroundHeight);
        $color = imagecolorallocate($imageRes, 0, 0, 0);
        imagefill($imageRes, 0, 0, $color);
        imagecopyresampled($imageRes, $background, 0, 0, 0, 0, imagesx($background), imagesy($background), imagesx($background), imagesy($background));
        if (!empty($config['image'])) {
            foreach ($config['image'] as $key => $val) {
                $val = array_merge($imageDefault, $val);
                $info = getimagesize($val['url']);
                $function = 'imagecreatefrom' . image_type_to_extension($info[2], false);
                if ($val['stream']) {
                    $info = getimagesizefromstring($val['url']);
                    $function = 'imagecreatefromstring';
                }
                $res = $function($val['url']);
                $resWidth = $info[0];
                $resHeight = $info[1];
                $canvas = imagecreatetruecolor($val['width'], $val['height']);
                imagefill($canvas, 0, 0, $color);
                imagecopyresampled($canvas, $res, 0, 0, 0, 0, $val['width'], $val['height'], $resWidth, $resHeight);
                $val['left'] = $val['left'] < 0 ? $backgroundWidth - abs($val['left']) - $val['width'] : $val['left'];
                $val['top'] = $val['top'] < 0 ? $backgroundHeight - abs($val['top']) - $val['height'] : $val['top'];
                imagecopymerge($imageRes, $canvas, $val['left'], $val['top'], $val['right'], $val['bottom'], $val['width'], $val['height'], $val['opacity']);//左，上，右，下，宽度，高度，透明度
            }
        }
        if (isset($config['text']) && !empty($config['text'])) {
            foreach ($config['text'] as $key => $val) {
                $val = array_merge($textDefault, $val);
                list($R, $G, $B) = explode(',', $val['fontColor']);
                $fontColor = imagecolorallocate($imageRes, $R, $G, $B);
                $val['left'] = $val['left'] < 0 ? $backgroundWidth - abs($val['left']) : $val['left'];
                $val['top'] = $val['top'] < 0 ? $backgroundHeight - abs($val['top']) : $val['top'];
                imagettftext($imageRes, $val['fontSize'], $val['angle'], $val['left'], $val['top'], $fontColor, $val['fontPath'], $val['text']);
            }
        }
        ob_start();
        imagejpeg($imageRes);
        imagedestroy($imageRes);
        $res = ob_get_contents();
        ob_end_clean();
        $key = substr(md5(rand(0, 9999)), 0, 5) . date('YmdHis') . rand(0, 999999) . '.jpg';
        $uploadType = (int)sys_config('upload_type', 1);
        $upload = UploadService::init();
        $res = $upload->to($path)->validate()->stream($res, $key);
        if ($res === false) {
            return $upload->getError();
        } else {
            $info = $upload->getUploadInfo();
            $info['image_type'] = $uploadType;
            return $info;
        }
    }


    /**
     * TODO 获取小程序二维码是否生成
     * @param $url
     * @return array
     */
    public static function remoteImage($url)
    {
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($curl);
        $result = json_decode($result, true);
        if (is_array($result)) return ['status' => false, 'msg' => $result['errcode'] . '---' . $result['errmsg']];
        return ['status' => true];
    }

    /**
     * TODO 修改 https 和 http 移动到common
     * @param $url $url 域名
     * @param int $type 0 返回https 1 返回 http
     * @return string
     */
    public static function setHttpType($url, $type = 0)
    {
        $domainTop = substr($url, 0, 5);
        if ($type) {
            if ($domainTop == 'https') $url = 'http' . substr($url, 5, strlen($url));
        } else {
            if ($domainTop != 'https') $url = 'https:' . substr($url, 5, strlen($url));
        }
        return $url;
    }


    /**
     * 获取二维码
     * @param $url
     * @param $name
     * @return array|bool|string
     */
    public static function getQRCodePath($url, $name)
    {
        if (!strlen(trim($url)) || !strlen(trim($name))) return false;
        try {
            $uploadType = 2;
            $info = [];
            $outfile = Config::get('qrcode.cache_dir');
            $code = new QRcode();
            $wapCodePath = $code->png($url, $outfile . '/' . $name)->getPath(); //获取二维码生成的地址
            $content = file_get_contents('.' . $wapCodePath);
            if ($uploadType === 1) {
                $info["code"] = 200;
                $info["name"] = $name;
                $info["dir"] = $wapCodePath;
                $info["time"] = time();
                $info['size'] = 0;
                $info['type'] = 'image/png';
                $info["image_type"] = 1;
                $info['thumb_path'] = $wapCodePath;
                return $info;
            } else {
                $upload = new Upload(2,config('upload')['stores']['qiniu']);
                $res = $upload->to($outfile)->validate()->stream($content, $name);
                if ($res === false) {
                    return $upload->getError();
                }
                $info = $upload->getUploadInfo();
                $info['image_type'] = $uploadType;
                return $info;
            }
        } catch (\Exception $e) {
            return $e->getMessage();
        }
    }

}
